      SUBROUTINE IDB7R(P,N1,M,A,H,X,F,S,IERR)
         INTEGER IERR,M,N1,P
         REAL A,F,H,S,X
         DIMENSION F(M)
         INTEGER I,I1,I2,J,J1,J2,J3,J4,K,K2,ML,N,N3,NL
         REAL B,C,D,R,RR,S1,T,TX,V,XM,XN,XX
         DIMENSION B(8),C(4),D(4),R(8),T(8)
       N = N1/2
       XX = X
       NL = 0
       ML = 0
       XM = A + (M - N - 1)*H
       XN = A + (N - 1)*H
       IF (N) 10, 10, 20
   10  CONTINUE
       IERR = 3
       GO TO 260
   20  CONTINUE
       K = (X - A)/H + 1 + 0.1E-10
       K2 = K
       IF ((X - A)*(A + (M - 1)*H - X)) 30, 40, 40
   30  CONTINUE
       IERR = 2
       GO TO 260
   40  CONTINUE
       S1 = S
       IF (K2 - N) 50, 60, 60
   50  CONTINUE
       X = XN + NL*H
       K = N
       NL = NL + 1
       TX = XN
       GO TO 80
   60  CONTINUE
       IF (K2 - M + N) 80, 80, 70
   70  CONTINUE
       X = XM - ML*H
       K = M - N
       ML = ML + 1
       TX = XM
   80  CONTINUE
       N3 = N + 1
       B(1) = 1
       IF (P - 1) 110, 110, 90
   90  CONTINUE
       DO 100 I = 2, P
          B(I) = B(I-1)*(N1 - I + 1)
  100  CONTINUE
  110  CONTINUE
       DO 130 I = 1, N
          T(I) = (X - A - (K - N + I - 1)*H)/H
          IF (N1 - P) 250, 120, 130
  120     CONTINUE
          T(I) = B(P)
          GO TO 140
  130  T(I) = (T(I)**(N1 - P))*B(P)
  140  CONTINUE
       DO 160 I = N3, N1
          T(I) = (A + (K - N + I - 1)*H - X)/H
          IF (N1 - P) 250, 150, 160
  150     CONTINUE
          T(I) = B(P)
          GO TO 170
  160  T(I) = T(I)**(N1 - P)*B(P)
  170  CONTINUE
       D(1) = 1
       D(2) = -N1
       D(3) = (N1 - 1)*N
       D(4) = -56
       C(1) = 1
       C(2) = 4
       C(3) = 66
       C(4) = 2416
       RR = C(N)*H**(P - 1)
       IF (RR) 180, 180, 190
  180  CONTINUE
       IERR = 1
       GO TO 260
  190  CONTINUE
       DO 210 I = 1, N
          I1 = N1 - I + 1
          V = 0
          DO 200 J = 1, I
             J1 = N - J + 1
             J2 = I - J + 1
             V = V + D(J2)*T(J1)
  200     CONTINUE
          R(I1) = V/RR
  210  CONTINUE
       DO 230 I = 1, N
          V = 0
          DO 220 J = 1, I
             J3 = J + N
             J4 = I - J + 1
             V = V + D(J4)*T(J3)
  220     CONTINUE
          R(I) = (-1)**(P + 1)*V/RR
  230  CONTINUE
       S = 0
       DO 240 I = 1, N1
          I2 = K - N + I
          S = S + F(I2)*R(I)
  240  CONTINUE
       C(1) = 1
       C(2) = 2.0/3.0
       C(3) = 11.0/20.0
       C(4) = 151.0/315.0
       S = C(N)*S
       IF (NL .EQ. 0 .AND. ML .EQ. 0) GO TO 270
          IF (NL .EQ. 1 .OR. ML .EQ. 1) GO TO 40
             IF (NL .EQ. 2) S = S1 + (S - S1)*(XX - TX)/H
             IF (ML .EQ. 2) S = S1 + (S1 - S)*(XX - TX)/H
             GO TO 270
  250  CONTINUE
       IERR = 4
       GO TO 260
  260  CONTINUE
       IF (IERR .NE. 0) CALL UTII12(IERR,2)
  270  CONTINUE
       RETURN
      END
